#include <stdio.h>
#include <math.h>
#include <GL/glut.H>

//f[^
int N; //f[^̐
float f[1000]; //f[^i[z f[i]  i ԖڂɃANZX (Ƃ肠\傫ȒŁAKvȂƂ낾g)
float h; //f[^̊Ԋu

int edge[1000];//GbW`߂̃f[^ (1 ̂ƂGbW)
int convex[1000]; //ʂ̕`߂̃f[^ (1̂ƂʁC0Ȃ牚, -1 ͕Ȃ)

//ۑ1-1 (܂ŕ`)
void drawData(){
  //
  glLineWidth(1); //͏ׂ
  glColor3f(0.8,1,0.8); //F͗ (ςĂ悢)
  //ȉ𖄂߂
  //forgĒ𗧂ĂĂ
  for(int i=0; i<N; i++){
    glBegin(GL_LINES);
      glVertex3f((float)i*h, 0, 0);
      glVertex3f((float)i*h, f[i], 0);
    glEnd();
  }
  
  //܂
  glLineWidth(3);
  glColor3f(0,0,0); //F͍ (ςĂ悢)
  //ȉ𖄂߂
  //forgĐ܂`Ă
  for(int i=0; i<N-1; i++){
    glBegin(GL_LINES);
      glVertex3f((float)i*h, f[i], 0);
      glVertex3f((float)(i+1)*h, f[i+1], 0);
    glEnd();
  }
}


//ۑ3-1 (GbW)
void detectEdge(){
  //1KlvZāAΒlKȒl傫
  //edge[i]  1 
  for(int i=1; i<N-1; i++){ //[͍EȂ̂ŌvZłȂ
    float d = (f[i+1] - f[i-1])/(2.0*h);
    if(fabs(d) > 5)
      edge[i] = 1;
    else
      edge[i] = 0;
  }
}


//ۑ3-2 (GbW`)
void drawEdge(){
  //for  edge[i] 𒲂ׂāA1 _`
  glPointSize(5);
  glColor3f(1,0,0); //F͐ (ςĂ悢)
  glBegin(GL_POINTS);
  for(int i=0; i<N; i++){
    if(edge[i] == 1)
      glVertex3f((float)i*h, f[i], 0);
  }
  glEnd();
}


//ۑ4-1 ()
void smooth(){
  float tmp[1000]; //VlꎞIɑ邽߂̔z
  
  //for ōE̒l̕ϒl temp[i] ֑ĂA
  //I V for  tmp[i]  f[i] ֑
  for(int i=1; i<N-1; i++){
    //E̕ϒlvZĈꎞ̈ɑ
    tmp[i] = 0.5*(f[i-1] + f[i+1]);
  }
  for(int i=1; i<N-1; i++){
    f[i] = tmp[i];
  }
}


//ۑ5-1 (GbWۑ)
void adaptiveSmooth(){
  float tmp[1000]; //VlꎞIɑ邽߂̔z
  
  //for ōE̒l̏dݕtϒl temp[i] ֑ĂA
  //I V for  tmp[i]  f[i] ֑
  float s = 1/(100*h*h); //p[^
  
  for(int i=1; i<N-1; i++){
    //d݂vZ
    float w1 = 1.0/(1.0 + s*pow(f[i-1]-f[i],2));
    float w2 = 1.0/(1.0 + s*pow(f[i+1]-f[i],2));
    //ȄdݕtϒlvZĈꎞ̈ɑ
    tmp[i] = (w1*f[i-1] + w2*f[i+1])/(w1+w2);
  }
  for(int i=1; i<N-1; i++){
    f[i] = tmp[i];
  }
}


//ۑ6-1  ۑ6-2 (Canny GbWo)
void CannyEdgeDetector(){
  float d[1000]; //1K̑傫z
  
  //܂ for  d[i] 1K̑傫
  //, V for ŃGbW̔B(GbWȂ edge[i]  1 )
  for(int i=1; i<N-1; i++)
     d[i] = fabs((f[i+1] - f[i-1])/(2*h));
  for(int i=2; i<N-2; i++)
    if(d[i] > d[i-1] && d[i] > d[i+1] && d[i] > 3) //x}ȂƂ
      edge[i] = 1;
    else
      edge[i] = 0;
}

//ۑ7-1 (ʂ̔)
void segment(){
  //2KlvZāA
  //Ȃ convex[i]  1 
  //Ȃ convex[i]  0 
  //[Ȃ convex[i]  -1 
  for(int i=1; i<N-1; i++){ 
    float dd = (f[i+1] + f[i-1] - 2*f[i])/(h*h);
    if(dd > 0)
      convex[i] = 1;
    else if(dd < 0)
      convex[i] = 0;
    else
      convex[i] = -1;
  }
}


//ۑ7-2 (ʂ̕`)
void drawSegment(){
  //for  convex[i] 𒲂ׂāA0 Ȃ物FA1Ȃ琅F̓_`
  glPointSize(5);
  glBegin(GL_POINTS);
  for(int i=0; i<N; i++){
    if(convex[i] == 1){
      glColor3f(0,1,1);
      glVertex3f((float)i*h, f[i], 0);
    }
    else if(convex[i] == 0){
      glColor3f(1,1,0);
      glVertex3f((float)i*h, f[i], 0);
    }
  }
  glEnd();
}

/************ ͉̉ۑɂ͊֌ŴȂ֐ (݂ȂĂ悢) *****************/

//_O̊֐
void display(void){ 
  //XN[ƕϊs
  glClear(GL_COLOR_BUFFER_BIT); 
  glLoadIdentity();
  
  drawData();//f[^`
  drawEdge();//GbW`
  drawSegment();
  
  glFlush(); //XN[XV
}

//t@Cf[^ǂݍފ֐
void readValues(char* file_name){
  FILE* in;
  fopen_s(&in, file_name, "r");
  
  fscanf_s(in, "%d", &N);
  for(int i=0; i<N; i++){
    fscanf_s(in, "%f", &f[i]);
    edge[i] = 0; //GbWłȂ悤ɂĂ
    convex[i] = -1; //ʂ͕sɂĂ
  }
  
  h = 1.0/(N-1); //(h  Nڂ̃f[^Ƃ 1 ɂȂ悤ɂ)
  fclose(in);
}

//L[{[hőΉ֐Ăяo
void keyboard(unsigned char key, int x, int y){
  switch (key) {
  case 's':
    printf("\n");
    smooth();
    display();
    break;
  case 'a':
    printf("GbWۑ\n");
    adaptiveSmooth();
    display();
    break;
  case 'e':
    printf("GbWo\n");
    detectEdge();
    display();
    break;
  case 'n':
    printf("Cannyo\n");
    CannyEdgeDetector();
    display();
    break;
  case 'h':
    printf("\n");
    segment();
    display();
    break;
  }
}

//EBhȆ傫ςɌĂ΂֐
void myReshape(int w, int h){
  glViewport(0, 0, w, h); //XN[̑傫߂
  
  //ϊsݒ
  glMatrixMode(GL_PROJECTION); 
  glLoadIdentity();
  
  //sê߂̃p[^ݒ
  //̈ (0,0,-1)  (1,1,1) R[i[Ɏ̂̒
  glOrtho(0, 1, //E
          0, 1, //
          -1, 1 //O
          );
  
  glMatrixMode(GL_MODELVIEW); //}``惂[h֐؂ւ
} 

void myinit(){
  //wi̐Fݒ (SԖڂ͓ߓxŒʏ͕sȂ̂ 1 ݒ)
  glClearColor (1, 1, 1, 1);

}

/**********************ȂƂ悢Ƃ낱܂***********************/

int main(int argc, char** argv){
  //ۑ1-2
  //ǂݍ߂f[^ "noisy", "wave", "cubic"
  readValues("data/noisy");
  //ۑ 7  wave g
  
  //EBhȄ
  glutInit(&argc, argv); 
  glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB); //gpobt@̐ݒ
  glutInitWindowSize(500, 500); //EBhȆ傫
  glutCreateWindow("prog2-1"); //EBhẼ^Cg
  
  myinit();//OpenGL ̏
  glutReshapeFunc(myReshape);//EBhETCYύXꂽɌĂ΂֐ݒ
  glutDisplayFunc(display); //EBhE̍XV̂߂̊֐ݒ
  glutKeyboardFunc(keyboard); //L[{[hꂽƂɌĂ΂֐ݒ
  glutMainLoop(); //C[v
  
  return 0;
}

